# This file is the entry point to configure your own services.
# Files in the packages/ subdirectory configure your dependencies.

# Put parameters here that don't need to change on each machine where the app is deployed
# https://symfony.com/doc/current/best_practices.html#use-parameters-for-application-configuration
parameters:
    email_confirmation_code_expire: P7D
    email_confirmation_link: https://mydomain.com/email-confirm

services:
    # default configuration for services in *this* file
    _defaults:
        autowire: true      # Automatically injects dependencies in your services.
        autoconfigure: true # Automatically registers your services as commands, event subscribers, etc.
        bind:
            $confirmationEmailTheme: 'Confirmation of registration'
            $newIpEmailTheme: 'Login from new ip'

    # makes classes in src/ available to be used as services
    # this creates a service per class whose id is the fully-qualified class name
    App\:
        resource: '../src/'
        exclude:
            - '../src/DependencyInjection/'
            - '../src/Entity/'
            - '../src/Kernel.php'

    # add more service definitions when explicit configuration is needed
    # please note that last definitions always *replace* previous ones
    App\ArgumentResolver\RequestDTOResolver:
        arguments:
            - '@validator'
        tags:
            - { name: controller.argument_value_resolver, priority: 50 }

    App\EventListener\ExceptionListener:
        tags:
            - { name: kernel.event_listener, event: kernel.exception }

    acme_api.event.jwt_created_listener:
        class: App\EventListener\JWTCreatedListener
        arguments: [ '@doctrine.orm.entity_manager' ]
        tags:
            - { name: kernel.event_listener, event: lexik_jwt_authentication.on_jwt_created, method: onJWTCreated }

    App\Util\RedisHelper:
        arguments:
            - '%env(REDIS_HOST)%'
            - '%env(REDIS_PASSWORD)%'

    App\Repository\CacheDecorator\Interfaces\PostRepositoryInterface: '@App\Repository\CacheDecorator\PostCacheRepository'
    App\Repository\CacheDecorator\Interfaces\PostLikeRepositoryInterface: '@App\Repository\CacheDecorator\PostLikeCacheRepository'
    App\Repository\CacheDecorator\Interfaces\UserRelationshipRepositoryInterface: '@App\Repository\CacheDecorator\UserRelationshipCacheRepository'
    App\Repository\CacheDecorator\Interfaces\UserProfileRepositoryInterface: '@App\Repository\CacheDecorator\UserProfileCacheRepository'
    App\Repository\CacheDecorator\Interfaces\MessageRepositoryInterface: '@App\Repository\CacheDecorator\MessageCacheRepository'
